"use strict";

const budoExpress = require("budo-express");
const path = require("path");

budoExpress({
	port: 3000,
	debug: true,
	expressApp: require("../src/server/app"),
	basePath: path.join(__dirname, ".."),
	entryPath: "src/client/index.jsx",
	publicPath: "public",
	bundlePath: "js/bundle.js",
	livereload: "**/*.{css,html,js}",
	browserify: {
		extensions: [".jsx"],
		plugin: [
			"browserify-hmr"
		],
		transform: [
			["babelify", {
				presets: ["@babel/preset-env", "@babel/preset-react"],
				// plugins: ["react-hot-loader/babel"]
			}],
			// ["aliasify", {
			// 	aliases: {
			// 		"react-dom": "@hot-loader/react-dom"
			// 	}
			// }]
		]
	}
});