"use strict";

const mapActions = require("./map-actions");

module.exports = function withArgumentActionMapper(func, mapper, options = {}) {
    return function (action) {
        if (action == null) {
            return func(action);
        } else {
            let mappedActions = mapActions(action, mapper);
            
            if (options.outputSingleDispatch) {
                return mappedActions.map((mappedAction) => {
                    return func(mappedAction);
                });
            } else {
                return func(mappedActions);
            }
        }
    }
};