"use strict";

const React = require("react");
const classnames = require("classnames");

const Frame = require("./frame");

function MainViewHeader({children, className}) {
	return (
		<div className={classnames("header", className)}>
			{children}
		</div>
	);
}

function MainViewContainer({children, className}) {
	return (
		<Frame className={classnames("mainView", className)}>
			{children}
		</Frame>
	);
}

let MainViewContents = React.forwardRef(({children, className}, ref) => {
	return (
		<div ref={ref} className={classnames("contents", className)}>
			{children}
		</div>
	)
});

module.exports = {
	Container: MainViewContainer,
	Header: MainViewHeader,
	Contents: MainViewContents
};