"use strict";

const dateFns = require("date-fns");

const types = require("./plumbing/types");

function viewInit(store) {
	// store.dispatch({type: "selectedAddFriendTab"});
	store.dispatch({type: "selectedConversationTab", username: "johndoe"});
}

module.exports = function (store) {
	store.dispatch({
		type: "connected",
		username: "joepie91",
		displayName: "Sven Slootweg",
		status: "online",
		friends: [types.Friend({
			username: "johndoe",
			displayName: "John Doe",
			statusVisible: true,
			status: "away",
			statusMessage: "Gone shopping",
			mutual: true
		})]
	});

	store.dispatch({
		type: "friends_added",
		friend: types.Friend({
			username: "foo",
			statusVisible: true
		})
	});

	store.dispatch({
		type: "friends_added",
		friend: types.Friend({
			username: "janedoe",
			displayName: "Jane Doe",
			statusVisible: false,
			statusMessage: "Some status message goes here",
			mutual: true
		})
	});

	store.dispatch({
		type: "messages_add",
		message: types.Message({
			id: 0,
			direction: "sent",
			sender: "joepie91",
			recipient: "johndoe",
			body: "Hi yes hello",
			timestamp: dateFns.subMinutes(Date.now(), 5),
			dbStored: true
		})
	});

	// store.dispatch({
	// 	type: "messages_dbStored",
	// 	messageId: 0
	// });

	store.dispatch({
		type: "messages_add",
		message: types.Message({
			id: 1,
			direction: "received",
			sender: "johndoe",
			recipient: "joepie91",
			body: "hi",
			timestamp: dateFns.subMinutes(Date.now(), 4)
		})
	});

	store.dispatch({
		type: "messages_add",
		message: types.Message({
			id: 2,
			direction: "sent",
			sender: "joepie91",
			recipient: "johndoe",
			body: "Foo Bar",
			timestamp: Date.now(),
			dbStored: true
		})
	});

	store.dispatch({
		type: "messages_add",
		message: types.Message({
			id: 3,
			direction: "sent",
			sender: "joepie91",
			recipient: "johndoe",
			body: "Foo Bar",
			timestamp: Date.now()
		})
	});

	for (let i = 0; i < 30; i++) {
		store.dispatch({
			type: "messages_add",
			message: types.Message({
				id: i+10,
				direction: "sent",
				sender: "joepie91",
				recipient: "johndoe",
				body: "Foo Bar",
				timestamp: Date.now()
			})
		});
	}
	for (let i = 0; i < 60; i++) {
		store.dispatch({
			type: "messages_add",
			message: types.Message({
				id: i+190,
				direction: "sent",
				sender: "joepie91",
				recipient: "foo",
				body: "Foo Bar",
				timestamp: Date.now()
			})
		});
	}

	store.dispatch({
		type: "invites_created",
		invite: types.Invite({
			id: 1,
			code: "abcdef",
			note: "Some random note goes here"
		})
	});

	store.dispatch({
		type: "invites_created",
		invite: types.Invite({
			id: 2,
			code: "ghijkl",
			note: "Another note goes here"
		})
	});

	// for (let i = 0; i < 30; i++) {
	// 	store.dispatch({
	// 		type: "invites_created",
	// 		invite: types.Invite({
	// 			id: i+10,
	// 			code: "blahblah",
	// 			note: "Blah blah blah"
	// 		})
	// 	});
	// }

	store.dispatch({
		type: "invites_consumed",
		inviteId: 1
	});

	viewInit(store);
};