"use strict";

const assureArray = require("assure-array");

module.exports = function mapDispatch(dispatchFunc, mapper) {
	return function dispatch(actions) {
		/* FIXME: This is probably creating a lot of unnecessary array allocations when mapped dispatches are nested. */

		let mappedActions = assureArray(actions).map((action) => {
			if (typeof action === "string") {
				return mapper({ type: action });
			} else {
				return mapper(action);
			}
		});
		
		mappedActions.forEach((action) => {
			dispatchFunc(action);
		});
	}
};