"use strict";

const types = require("../plumbing/types");

module.exports = {
	name: "uiInviteFriend",
	mixins: [
		require("./mixins/form")({
			validate: ({allow}) => {
				allow();
			},
			process: ({formData, api}) => {
				return api.createInvite({
					note: formData.note
				});
			},
			success: ({result}) => {
				let invite = types.Invite(result.invite);
				
				return [{
					type: "@invites_created",
					invite: invite
				}];
			}
		})
	]
};