"use strict";

const nanoid = require("nanoid");

const types = require("../plumbing/types");

/* MARKER: Implement message sending */
/* TODO: Consider whether it makes sense to specify a particular action property as the key for a form. instead of having a separate key property; that would probably reduce the needed complexity of key properties being merged into actions and dispatches, and would allow for writing more semantically correct code, because it can eg. refer to `recipient: action.username` instead of `recipient: key` or even `recipient: action.key`. */
/* TODO: Make the form abstraction a little more organized; there's a lot of explicit copying of properties etc. going on right now, and it should be possibe to unify this into a single 'create mixin'-type abstraction that the form mixin can then use to make a neatly organized implementation of parameterizable form logic */

module.exports = {
	name: "uiMessageInput",
	mixins: [
		require("./mixins/form")({
			transform: ({globalState, formData, key, allow, reject}) => {
				let {body} = formData;

				if (body == null) {
					/* No message was entered */
					reject();
				} else {
					allow({
						type: "@messages_add",
						message: types.Message({
							id: nanoid(),
							direction: "sent",
							sender: globalState.username,
							recipient: key,
							body: body,
							timestamp: new Date()
						})
					});
				}
			},
			// validate: ({globalState, formData, allow, reject}) => {
			// 	let {body} = formData;

			// 	if (body == null) {
			// 		/* No message was entered */
			// 		reject();
			// 	} else {
			// 		allow();
			// 	}

			// 	// let {username} = formData;

			// 	// if (username == null) {
			// 	// 	reject({
			// 	// 		errorType: "noUsernameSpecified",
			// 	// 		errorMessage: "You must specify a username.",
			// 	// 		invalidFields: ["username"]
			// 	// 	});
			// 	// } else if (globalState.modules.friends.friends.has(username)) {
			// 	// 	reject({
			// 	// 		errorType: "friendAlreadyInList",
			// 	// 		/* TODO: Make error message clearer, maybe include display name of existing entry? */
			// 	// 		errorMessage: "There's already a user with that username in your friends list.",
			// 	// 		invalidFields: ["username"]
			// 	// 	});
			// 	// } else {
			// 	// 	allow();
			// 	// }
			// },
			process: ({formData, api}) => {
				return;

				
				// return api.addFriend({
				// 	username: formData.username
				// });
			},
			success: ({result, action}) => {
				// let friend = types.Friend(result.friend);

				// return [{
				// 	type: "@friends_added",
				// 	friend: friend
				// }, {
				// 	type: "@friends_addedDbStored",
				// 	username: friend.username,
				// 	optional: true
				// }, {
				// 	type: "@selectedConversationTab",
				// 	username: friend.username
				// }];
			}
		})
	]
};