"use strict";

const redux = require("redux");
const reduxLogic = require("redux-logic");

const loadModules = require("./module-loader");
const globalStateTransformations = require("./global-state-transformations");
const globalDefaultState = require("./global-default-state");
const mockApi = require("./mock-api");

function reducer(state, action) {
	// return match(action.type, {
	// 	selectedConversationTab: () => {
	// 		let {username} = action;

	// 		return state.merge({
	// 			selectedTabType: "conversation",
	// 			selectedTab: username
	// 		});
	// 	},
	// 	selectedAddFriendTab: () => {
	// 		return state.merge({
	// 			selectedTabType: "meta",
	// 			selectedTab: "addFriend"
	// 		});
	// 	},
	// 	uiAddFriendProcessing: () => {
	// 		return state.updateIn(["uiAddFriend"], (formState) => {
	// 			return formState.merge({
	// 				processing: true,
	// 				errorMessage: null
	// 			});
	// 		});
	// 	},
	// 	uiAddFriendError: () => {
	// 		let {errorMessage} = action;

	// 		return state.updateIn(["uiAddFriend"], (formState) => {
	// 			return formState.merge({
	// 				processing: false,
	// 				errorMessage: errorMessage
	// 			});
	// 		});
	// 	},
	// 	uiAddFriendComplete: () => {
	// 		return state.setIn(["uiAddFriend", "processing"], false);
	// 	},
	// 	connected: () => {
	// 		let {username, displayName, statusMessage, status, friends} = action;

	// 		return state.merge({
	// 			connected: true,
	// 			username: username,
	// 			displayName: displayName,
	// 			status: validateStatus(status),
	// 			statusMessage: statusMessage,
	// 			friends: immutable.Map(friends.map((friend) => {
	// 				return [friend.username, friend];
	// 			}))
	// 		});
	// 	},
	// 	disconnected: () => {
	// 		return state.merge({
	// 			connected: false
	// 		});
	// 	},
	// 	userChangedStatus: () => {
	// 		let {status} = action;

	// 		return state.set("status", validateStatus(status));
	// 	},
	// 	userChangedStatusMessage: () => {
	// 		let {statusMessage} = action;

	// 		return state.set("statusMessage", statusMessage);
	// 	},
	// 	userChangedDisplayName: () => {
	// 		let {displayName} = action;

	// 		return state.merge({
	// 			displayName: displayName,
	// 			displayNameDBStored: false
	// 		});
	// 	},
	// 	userChangedDisplayNameDBStored: () => {
	// 		return state.set("displayNameDBStored", true);
	// 	},
	// 	userStartedTyping: () => {
	// 		let {recipient} = action;

	// 		return state.updateIn(["isTypingTo"], (friends) => {
	// 			return friends.add(recipient);
	// 		});
	// 	},
	// 	userPausedTyping: () => {
	// 		let {recipient} = action;

	// 		return state.updateIn(["pausedTypingTo"], (friends) => {
	// 			return friends.add(recipient);
	// 		});
	// 	},
	// 	userResumedTyping: () => {
	// 		let {recipient} = action;

	// 		return state.updateIn(["pausedTypingTo"], (friends) => {
	// 			return friends.delete(recipient);
	// 		});
	// 	},
	// 	userStoppedTyping: () => {
	// 		let {recipient} = action;

	// 		return state.updateIn(["isTypingTo"], (friends) => {
	// 			return friends.delete(recipient);
	// 		});
	// 	},
	// 	friendChangedStatus: () => {
	// 		let {username, status} = action;

	// 		/* TODO: Figure out a way to express the branching below in a functional, expression-based manner. */
	// 		let state_ = state.setIn(["friends", username, "status"], status);

	// 		if (status === "offline") {
	// 			return state_.update(clearFriendState(username));
	// 		} else {
	// 			return state_;
	// 		}
	// 	},
	// 	friendChangedStatusMessage: () => {
	// 		let {statusMessage} = action;

	// 		return state.setIn(["friends", username, "statusMessage"], statusMessage);
	// 	},
	// 	friendChangedDisplayName: () => {
	// 		let {username, displayName} = action;

	// 		return state.setIn(["friends", username, "displayName"], displayName);
	// 	},
	// 	friendStartedTyping: () => {
	// 		return state.setIn(["friends", username, "isTyping"], true);
	// 	},
	// 	friendPausedTyping: () => {
	// 		return state.setIn(["friends", username, "pausedTyping"], true);
	// 	},
	// 	friendResumedTyping: () => {
	// 		return state.setIn(["friends", username, "pausedTyping"], false);
	// 	},
	// 	friendStoppedTyping: () => {
	// 		return state.setIn(["friends", username, "isTyping"], false);
	// 	},
	// 	messageReceived: () => {
	// 		let {message} = action;

	// 		return state
	// 			.update(addMessage(message.sender, message.merge({
	// 				direction: "received",
	// 				delivered: true,
	// 				deliveredDBStored: true
	// 			})));
	// 	},
	// 	messageReceivedDBStored: () => {
	// 		let {messageId} = action;

	// 		return state.update(markMessageDbStored(messageId));
	// 	},
	// 	messageSent: () => {
	// 		let {message} = action;

	// 		return state
	// 			.update(addMessage(message.recipient, message.merge({
	// 				direction: "sent"
	// 			})));
	// 	},
	// 	messageSentDBStored: () => {
	// 		let {messageId} = action;

	// 		return state.update(markMessageDbStored(messageId));
	// 	},
	// 	messageDelivered: () => {
	// 		// Defined as at least one device of the recipient having received the message, and acknowledged as such
	// 		let {messageId} = action;

	// 		return state.mergeIn(["messages", messageId], {
	// 			delivered: true,
	// 			queuedForOfflineDelivery: false
	// 		});
	// 	},
	// 	messageDeliveredDBStored: () => {
	// 		let {messageId} = action;

	// 		return state.setIn(["messages", messageId, "deliveredDBStored"], true);
	// 	},
	// 	messageQueuedForOfflineDelivery: () => {
	// 		let {messageId} = action;

	// 		return state.setIn(["messages", messageId, "queuedForOfflineDelivery"], true);
	// 	},
	// 	friendAdded: () => {
	// 		let {friend} = action;
			
	// 		return state.updateIn(["friends"], (friends) => friends.set(friend.username, friend));
	// 	},
	// 	friendAddedDBStored: () => {
	// 		let {username} = action;

	// 		return state.setIn(["friends", username, "dbStored"], true);
	// 	},
	// 	friendRemoved: () => {
	// 		let {username} = action;

	// 		return state.updateIn(["friends"], (friends) => friends.delete(username));
	// 	},
	// 	friendRemovedDBStored: () => {
	// 		/* Do nothing for now, there's not really a reasonable way to represent this in the current state tree structure. */
			
	// 		return state;
	// 	},
	// 	friendRequestReceived: () => {
	// 		let {request} = action;

	// 		return state.updateIn(["friendRequests"], (requests) => requests.set(request.username, request));
	// 	},
	// 	friendRequestWithdrawn: () => {
	// 		let {username} = action;

	// 		return state.update(removeFriendRequest(username));
	// 	},
	// 	friendRequestAccepted: () => {
	// 		let {username} = action;

	// 		/* NOTE: This *only* handles the `friendRequests` entry, not the addition to the friends list. That's a separate `friendAdded` action. */

	// 		return state.update(removeFriendRequest(username));
	// 	},
	// 	friendRequestedAcceptedDBStored: () => {
	// 		/* Nothing? */
	// 		return state;
	// 	},
	// 	friendRequestRejected: () => {
	// 		let {username} = action;

	// 		return state.update(removeFriendRequest(username));
	// 	},
	// 	friendRequestRejectedDBStored: () => {
	// 		/* Nothing? */
	// 		return state;
	// 	},
	// 	_: () => {
	// 		return state;
	// 	}
	// });
}

let modules = [
	require("../modules/friends"),
	require("../modules/add-friend"),
	require("../modules/friend-requests"),
	require("../modules/invites"),
	require("../modules/invite-friend"),
	require("../modules/messages"),
	require("../modules/ui-message-input"),
];

function withDevTools(...enhancers) {
	if (window != null && window.__REDUX_DEVTOOLS_EXTENSION__ != null) {
		return redux.compose(...enhancers, window.__REDUX_DEVTOOLS_EXTENSION__());
	} else {
		return redux.compose(...enhancers);
	}
	/* FIXME: Check if returning `undefined` here is valid */
}

function createReducer(stateTransformations, missingActionWhitelist) {
	return function reducer(state, action) {
		let handler = stateTransformations[action.type];

		if (handler != null) {
			return handler(state, action)
		} else {
			/* FIXME: Log a warning here? */
			if (action.type.startsWith("@@") || action.optional || missingActionWhitelist.has(action.type)) {
				return state;
			} else {
				throw new Error(`Unknown action type: ${action.type}`);
			}
		}
	}
}

function initializeStore({modules, logicDependencies, state}) {
	let {State, stateTransformations, logicHandlers} = loadModules(modules, {
		stateTransformations: globalStateTransformations,
		state: state
	});

	let logicMiddleware = reduxLogic.createLogicMiddleware(logicHandlers, logicDependencies);
	let logicEnhancer = redux.applyMiddleware(logicMiddleware);
	let enhancers = withDevTools(logicEnhancer);
	// let enhancers = redux.compose(logicEnhancer, createDevToolsEnhancer());

	let missingActionWhitelist = new Set(logicHandlers.map((handler) => handler.type));
	let reducer = createReducer(stateTransformations, missingActionWhitelist);
	
	let initialState = State();

	return redux.createStore(reducer, initialState, enhancers);
}

module.exports = {
	createStore: function createStore(initialState = globalDefaultState) {
		/* QUESTION: Does the default state merging order need to be swapped around so that unscoped comes last, such that the above initialState parameter can be used to initialize module state as well? */
		return initializeStore({
			state: initialState,
			modules: modules,
			logicDependencies: {
				api: mockApi
			}
		});
	}
};

