"use strict";

const Promise = require("bluebird");
const nanoidGenerate = require("nanoid/generate");

module.exports = {
	addFriend: function addFriend({username}) {
		return Promise.try(() => {
			return Promise.delay(500);
		}).then(() => {
			return {
				friend: {
					username: username
				}
			};
		});
	},
	createInvite: function createInvite({note}) {
		return Promise.try(() => {
			return Promise.delay(500);
		}).then(() => {
			let code = nanoidGenerate("2346789ABCDEFGHIJKLMNOPQRSTUVWXYZ", 18);
			
			return {
				invite: {
					id: code,
					code: code,
					note: note
				}
			};
		});
	},
	deleteInvite: function deleteInvite({id}) {
		return Promise.try(() => {
			return Promise.delay(500);
		}).then(() => {
			return {
				inviteId: id
			};
		});
	},
	acceptFriendRequest: function acceptFriendRequest({username}) {
		return Promise.try(() => {
			return Promise.delay(500);
		}).then(() => {
			return {
				friend: {
					username: username,
					displayName: `The name is ${username}`,
					status: "online"
				}
			};
		})
	},
	rejectFriendRequest: function rejectFriendRequest({username}) {
		return Promise.delay(500);
	},
	sendMessage: function sendMessage({message}) {
		// throw new Error("foo");
		return Promise.delay(4500);
	}
};