"use strict";

module.exports = function scopedKey(moduleName, key) {
	if (key == null) {
		return key;
	} else if (key.startsWith("@")) {
		if (moduleName != null) {
			return key.slice(1);
		} else {
			throw new Error("Attempted to use a global key specifier (@) in a module without a name; this is not allowed");
		}
	} else {
		if (moduleName != null) {
			return `${moduleName}_${key}`;
		} else {
			return key;
		}
	}
};