"use strict";

module.exports = function match(value, options) {
    if (options[value] != null) {
        if (typeof options[value] === "function") {
            return options[value]();
        } else {
            return options[value];
        }
    } else if (options._ != null) {
        if (typeof options._ === "function") {
            return options._();
        } else {
            return options._;
        }
    } else {
        throw new Error(`No handler defined for value '${value}', and no catch-all defined either`);
    }
};